﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration
Imports System.Web.Services

Partial Class VB
    Inherits System.Web.UI.Page

    <WebMethod()> _
    Public Shared Function GetChart(country1 As String, country2 As String) As List(Of Object)
        Dim chartData As New List(Of Object)()
        Dim query As String = "SELECT DISTINCT DATEPART(YEAR, OrderDate) Year FROM Orders"
        Dim dtYears As DataTable = GetData(query)
        Dim labels As New List(Of Integer)()
        For Each row As DataRow In dtYears.Rows
            labels.Add(Convert.ToInt32(row("Year")))
        Next
        chartData.Add(labels)

        query = "SELECT DATEPART(YEAR, OrderDate) Year, COUNT(DATEPART(YEAR, OrderDate)) TotalOrders"
        query += " FROM Orders WHERE ShipCountry = '" & country1 & "' GROUP BY DATEPART(YEAR, OrderDate)"
        Dim dtCountry1 As DataTable = GetData(query)

        Dim series1 As New List(Of Integer)()
        For Each row As DataRow In dtCountry1.Rows
            series1.Add(Convert.ToInt32(row("TotalOrders")))
        Next
        chartData.Add(series1)

        query = "SELECT DATEPART(YEAR, OrderDate) Year, COUNT(DATEPART(YEAR, OrderDate)) TotalOrders"
        query += " FROM Orders WHERE ShipCountry = '" & country2 & "' GROUP BY DATEPART(YEAR, OrderDate)"
        Dim dtCountry2 As DataTable = GetData(query)

        Dim series2 As New List(Of Integer)()
        For Each row As DataRow In dtCountry2.Rows
            series2.Add(Convert.ToInt32(row("TotalOrders")))
        Next
        chartData.Add(series2)

        Return chartData
    End Function

    Private Shared Function GetData(query As String) As DataTable
        Dim dt As New DataTable()
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand(query)
                Using sda As New SqlDataAdapter()
                    cmd.CommandType = CommandType.Text
                    cmd.Connection = con
                    sda.SelectCommand = cmd
                    sda.Fill(dt)
                End Using
            End Using
            Return dt
        End Using
    End Function
End Class